<template>
  <div>
    <b-tabs class="block">
      <b-tab-item icon="bar-chart" :label="$t('emissions.t.co2e.short')">
        <br />
        <highcharts :options="DTEmissionOptions"></highcharts>
        <br />
        <b-table
          :striped="true"
          :narrowed="true"
          :hoverable="true"
          :data="commutesEmissions"
          :columns="columnsModes"
        />
      </b-tab-item>
      <b-tab-item icon="bar-chart" :label="$t('distances.km')">
        <br />
        <highcharts :options="DTDistanceOptions"></highcharts>
        <br />
        <b-table
          :striped="true"
          :narrowed="true"
          :hoverable="true"
          :data="commutesDistances"
          :columns="columnsModes"
        />
      </b-tab-item>
    </b-tabs>
  </div>
</template>

<script>
import Commute from '@/models/carbon/Commute.js'
import '@/plugins/highcharts.js'

export default {
  name: 'PlotsCommutes',
  data () {
    return {
      DTDistanceOptions: {
        chart: {
          type: 'column'
        },
        title: {
          text: ''
        },
        credits: {
          enabled: false
        },
        series: [],
        xAxis: {
          categories: Commute.travelsModes.map(val => this.$t(val)),
          crosshair: true
        },
        yAxis: {
          min: 0,
          title: {
            text: this.$t('distances.km')
          }
        },
        exporting: {
          buttons: {
            contextButton: {
              menuItems: ['downloadPNG', 'downloadJPEG', 'downloadPDF', 'downloadSVG']
            }
          },
          chartOptions: {
            chart: {
              width: 750,
              height: 400
            }
          }
        },
        tooltip: {
          shared: true,
          valueDecimals: 0,
          valueSuffix: ' km'
        }
      },
      DTEmissionOptions: {
        chart: {
          type: 'column'
        },
        title: {
          text: ''
        },
        credits: {
          enabled: false
        },
        series: [],
        xAxis: {
          categories: Commute.travelsModes.map(val => this.$t(val)),
          crosshair: true
        },
        yAxis: {
          min: 0,
          title: {
            text: this.$t('emissions.t.co2e.short')
          }
        },
        exporting: {
          buttons: {
            contextButton: {
              menuItems: ['downloadPNG', 'downloadJPEG', 'downloadPDF', 'downloadSVG']
            }
          },
          chartOptions: {
            chart: {
              width: 750,
              height: 400
            }
          }
        },
        tooltip: {
          shared: true,
          valueDecimals: 2,
          valueSuffix: ' ' + this.$t('t.co2e')
        }
      }
    }
  },
  computed: {
    results: function () {
      return this.$store.getters['commutes/results']
    },
    columnsModes: function () {
      let columns = [{
        'field': 'Statut',
        'label': 'Statut',
        'sticky': true
      }]
      for (let mode of Commute.travelsModes) {
        columns.push({
          'field': mode,
          'label': this.$t(mode),
          'numeric': true
        })
      }
      return columns
    },
    commutesEmissions: function () {
      let toReturn = []
      if (this.$store.getters['commutes/computed']) {
        let results = this.results.status.intensity
        for (let status of Object.keys(results)) {
          let catObject = {}
          let i = 0
          for (let cat of Commute.travelsModes) {
            catObject[cat] = '<nobr>' + this.$options.filters.splitNumberTons(results[status][i].intensity) + ' +/- ' + this.$options.filters.splitNumberTons(results[status][i].uncertainty) + '</nobr>'
            i += 1
          }
          if (status === 'researcher') {
            catObject['Statut'] = '<nobr>' + this.$t('professors.researchers') + '</nobr>'
          } else if (status === 'engineer') {
            catObject['Statut'] = '<nobr>' + this.$t('engineers') + '</nobr>'
          } else {
            catObject['Statut'] = '<nobr>' + this.$t('students') + '</nobr>'
          }
          toReturn.push(catObject)
        }
      }
      return toReturn
    },
    commutesDistances: function () {
      let toReturn = []
      if (this.$store.getters['commutes/computed']) {
        let results = this.results.status.distances
        for (let status of Object.keys(results)) {
          let catObject = {}
          let i = 0
          for (let cat of Commute.travelsModes) {
            catObject[cat] = this.$options.filters.splitNumber(results[status][i])
            i += 1
          }
          if (status === 'researcher') {
            catObject['Statut'] = '<nobr>' + this.$t('professors.researchers') + '</nobr>'
          } else if (status === 'engineer') {
            catObject['Statut'] = '<nobr>' + this.$t('engineers') + '</nobr>'
          } else {
            catObject['Statut'] = '<nobr>' + this.$t('students') + '</nobr>'
          }
          toReturn.push(catObject)
        }
      }
      return toReturn
    }
  },
  methods: {
    process: function () {
      if (this.$store.getters['commutes/computed']) {
        this.DTDistanceOptions.series = [
          {
            name: this.$t('professors.researchers'),
            data: this.results.status.distances.researcher
          },
          {
            name: this.$t('engineers'),
            data: this.results.status.distances.engineer
          },
          {
            name: this.$t('students'),
            data: this.results.status.distances.student
          }
        ]
        this.DTEmissionOptions.series = [
          {
            name: this.$t('professors.researchers'),
            data: this.results.status.intensity.researcher.map(obj => obj.intensity / 1000)
          },
          {
            name: this.$t('engineers'),
            data: this.results.status.intensity.engineer.map(obj => obj.intensity / 1000)
          },
          {
            name: this.$t('students'),
            data: this.results.status.intensity.student.map(obj => obj.intensity / 1000)
          }
        ]
      }
    }
  },
  mounted () {
    if (!this.$store.getters['commutes/computed']) {
      this.$store.dispatch('commutes/compute')
    }
    this.process()
  }
}
</script>

<style>
.is-sticky {
  background: #fafafa !important;
}
.table td {
  vertical-align: middle !important;
}
</style>
